<?php
class DB{

	private $dbhost;
	private $dbname;
	private $dbuser;
	private $dbpass;
	private $ka_file='/var/run/analyticsd.keepalive';
	private $alias;
	public $dbconn;

	function DB(){
		require_once('config.php');
		global $dbhost,$dbname,$dbpass,$dbuser,$distros;
		
		$this->dbhost=$dbhost;
		$this->dbname=$dbname;
		$this->dbpass=$dbpass;
		$this->dbuser=$dbuser;
		$this->alias=array();
		$this->info_distro=json_decode($distros,true);
		if ($this->info_distro == NULL){
		    die('Error: Wrong json in Config.php');
		}
		$this->init_dates();
		$this->times=0;
	}
	function init_dates(){
		$this->dates=array();
		$this->dates['today']=date("Y-m-d");
	        $this->dates['first_current']=date("Y-m-").'01';
	        $this->dates['last_old']=date("Y-m-d",strtotime($this->dates['first_current']." -1 days"));
	        $this->dates['first_old']=date("Y-m-",strtotime($this->dates['today']. "-1 months")).'01';
	        $this->dates['last_very_old']=date("Y-m-d",strtotime($this->dates['first_old']." -1 days"));
	        $this->dates['first_very_old']=date("Y-m-",strtotime($this->dates['first_old']." -1 days")).'01';
	        $this->dates['date_current']="(date between '".$this->dates['first_current']."' and '".$this->dates['today']."')";
	        $this->dates['date_old']="(date between '".$this->dates['first_old']."' and '".$this->dates['last_old']."')";
	        $this->dates['date_very_old']="(date between '".$this->dates['first_very_old']."' and '".$this->dates['last_very_old']."')";
	        $this->dates['date_range_last_three_months']="(date between '".$this->dates['first_very_old']."' and '".$this->dates['today']."')";

	}
	function connect(){
		$this->dbconn=new mysqli($this->dbhost, $this->dbuser , $this->dbpass, $this->dbname);
		if ($this->dbconn->connect_error) {
    		    die('Connect Error:'. $this->dbconn->connect_error);
		}
	}
	function disconnect(){
		$this->dbconn->close();
	}
	function init_trans(){
		$this->dbconn->autocommit(FALSE);
		$this->dbconn->begin_transaction(MYSQLI_TRANS_START_READ_WRITE);
	}

        function send_data($user,$version,$sabor,$apps,$date=''){
            if ($date == ''){
                $sql="INSERT INTO tmp_clients(user,version,sabor,status) values ('$user','$version','$sabor',0)";
            }else{
                $sql="INSERT INTO tmp_clients(user,version,sabor,status,date) values ('$user','$version','$sabor',0,'$date')";
            }
            $retry=1;
            $done=false;
            $cli_id=false;
            while (! $done and $retry < 4){
                $res=$this->dbconn->query($sql);
                if ($res){
                    $cli_id=$this->dbconn->insert_id; 
                    $done=true;
                }else{
                    $retry+=1;
                    sleep($retry);
                }
            }
            if ($retry == 4 or $cli_id == false)
                    throw new Exception('Error sending client data: '.$this->dbconn->error);
            $err_apps=false;
            $err_exception=false;
            if (count($apps) != 0){
                if ($date == ''){
                    $sql="insert into tmp_packages(client,app,value) values";
                }else{
                    $sql="insert into tmp_packages(client,app,value,date) values";
                }
                $values=array();
                foreach ($apps as $app => $value){
                    if (trim($app) == '' or trim($value) == ''){
                        $err_apps=true;
                        $err_exception=new Exception('Wrong application values');
                        continue;
                    }
                    if ($date == ''){
                        $values[]="($cli_id,'$app',$value)";
                    }else{
                        $values[]="($cli_id,'$app',$value,'$date')";
                    }
                }
                if (count($values) > 0){
                    $sql.=implode(',',$values);
                    $done=false;
                    $retry=1;
                    while (! $done and $retry < 4){
                        $res=$this->dbconn->query($sql);
                        if ($res){
                            $done=true;
                        }else{
                            $retry += 1;
                            sleep($retry);
                        }
                    }
                    if ($retry == 4 or ! $done){
                        $err_apps=true;
                        $err_exception=new Exception('Error sending client app data: '.$this->dbconn->error.' QUERY='.$sql);
                    }
                }
            }
            //End operations
            $sql = "Update tmp_clients set status=1 where id = $cli_id and status=0";
            $retry=1;
            $done=false;
            while (! $done and $retry < 4){
                $res=$this->dbconn->query($sql);
                if ($res){
                    $done=true;
                }else{
                    $retry+=1;
                    sleep($retry);
                }
            }
            if ($retry == 4 or $cli_id == false){
                throw new Exception('Error commiting client data: '.$this->dbconn->error);
            }
            if ($err_apps){
                throw $err_exception;
            }
        }

	private function load_alias(){
		$sql="SELECT name,alias from Alias";
		$result=$this->dbconn->query($sql);
		while($row=$result->fetch_array(MYSQLI_ASSOC)){
			$this->alias[$row['name']]=$row['alias'];
		}
	}
	function get_extended_data($app){
	    $today=date("Y-m-d");
	    $min_date=date("Y-m",strtotime($today." -1 year")).'-01';
	    $this->times=0;
	    // CLIENTS DISTRIBUTION PER RELEASE/FLAVOUR
	    $sql="select year(date) as year,month(date) as month,Releases_name,Flavours_name,count(*) as num_hosts from (select distinct Client_uid,date,Releases_name,Flavours_name from Client_Versions where date >= '$min_date' )t group by year,month,Releases_name,Flavours_name order by year Desc,month desc,Releases_name asc,num_hosts desc";
	    $stime=microtime(true);
	    $result=$this->dbconn->query($sql);
	    if ($result){
	        $this->times+=microtime(true)-$stime;
	        $clients_month=[];
	        $tmp=[];
	        while($row=$result->fetch_array(MYSQLI_ASSOC)){
	            $date=$row['year'].'_'.$row['month'];
	            $tmp[$date][$row['Releases_name']][$row['Flavours_name']]=intval($row['num_hosts']);
	        }
	        foreach ($tmp as $date){
	            $clients_month[]=$date;
	        }
	    }else{
	        $clients_month=$this->dbconn->error;
	    }
	    // CLIENT UPDATES
	    $sql="select year,month,count(*) as nclients,sum(cnt)-count(*) as nclients_updated from (select Client_uid,count(Client_uid) as cnt,year(date) as year,month(date) as month from Client_Versions where date >= '$min_date' GROUP by Client_uid,year,month having count(Client_uid) >= 1 ) t group by year,month order by year desc,month desc";
	    $sql="select year,month,count(*) as nclients,sum(cnt)-count(*) as nclients_updated,Releases_name as rel,Flavours_name as fla from (select Client_uid,count(Client_uid) as cnt,year(date) as year,month(date) as month,Releases_name,Flavours_name from Client_Versions where date >= '$min_date' GROUP by Client_uid,year,month,Releases_name,Flavours_name having count(Client_uid) >= 1 ) t group by year,month,Releases_name,Flavours_name order by year desc,month desc";
	    $stime=microtime(true);
	    $result=$this->dbconn->query($sql);
	    if ($result){
	        $this->times+=microtime(true)-$stime;
	        $i=0;
		$tmp=[];
	        while($row=$result->fetch_array(MYSQLI_ASSOC)){
	            $date=$row['year'].'_'.$row['month'];
		    $tmp[$date][$row['rel']][$row['fla']]=intval($row['nclients_updated']);
	        }
		foreach($tmp as $date){
		    $num_updates_month[]=$date;
		}
	    }else{
	        $num_updates_month=$this->dbconn->error;
	    }
	    // CLIENT CHANGE RELEASE
	    $sql="select year,month,count(*) as upgrades_en_mes from (select year,month,Client_uid as cliente_upgradeado from (select Client_uid,year(date) as year,month(date) as month from Client_Versions where date >= '$min_date' GROUP by Client_uid,Releases_name,year,month)t group by month,year,Client_uid having(count(*))>1)t group by year,month order by year desc,month desc limit 12";
	    $stime=microtime(true);
	    $result=$this->dbconn->query($sql);
	    if ($result){
	        $this->times+=microtime(true)-$stime;
	        $change_releases=[0,0,0,0,0,0,0,0,0,0,0,0];
	        $i=0;
	        while($row=$result->fetch_array(MYSQLI_ASSOC)){
	            $change_releases[$i++]=intval($row['upgrades_en_mes']);
	        }
	    }else{
	        $change_releases=$this->dbconn->error;
	    }
	    // CLIENT CHANGE FLAVOUR
	    $sql="select year,month,count(*) as cambio_sabor_en_mes from (select year,month,Client_uid as cliente_upgradeado from (select Client_uid,year(date) as year,month(date) as month from Client_Versions where date >= '$min_date' GROUP by Client_uid,Flavours_name,year,month)t group by month,year,Client_uid having(count(*))>1)t group by year,month order by year desc,month desc limit 12";
	    $stime=microtime(true);
	    $result=$this->dbconn->query($sql);
	    if ($result){
	        $this->times+=microtime(true)-$stime;
	        $i=0;
	        $change_flavour=[0,0,0,0,0,0,0,0,0,0,0,0];
	        while($row=$result->fetch_array(MYSQLI_ASSOC)){
	            $change_flavour[$i++]=intval($row['cambio_sabor_en_mes']);
	        }
	    }else{
	        $change_flavour=$this->dbconn->error;
	    }
	    
	    //sanitize input
	    if ($app != NULL){
	        $app=preg_grep('/^[a-zA-Z0-9\-_]+$/',array($app));
	        if ($app != NULL and isset($app[0])){
	            $app=$this->dbconn->real_escape_string($app[0]);
	            $stats['apps']=[];
	            $stats['apps']['app']=$app;
	            $sql="select year(date) as year,month(date) as month,string,Releases_name as rel,Flavours_name as fla,sum(count) as count from RecvPackages where string='$app' and date >= '$min_date' group by year,month,Releases_name,Flavours_name order by year desc,month desc,sum(count) desc";
	            $stime=microtime(true);
	            $result=$this->dbconn->query($sql);
	            if ($result){
	                $this->times+=microtime(true)-$stime;
	                $tmp=[];
	                while($row=$result->fetch_array(MYSQLI_ASSOC)){
	                    $date=$row['year'].'_'.$row['month'];
		            $tmp[$date][$row['rel']][$row['fla']]=intval($row['count']);
	                }
		        foreach($tmp as $date){
		            $app_use[]=$date;
		        }
	                $stats['apps']['app_use']=$app_use;
	            }else{
	                $app_use=$this->dbconn->error;
	            }
	        }
	    }
	    // FINALIZATION & WRITE STRUCTURE
	    if (isset($clients_month)){
	        $stats['clients']['clients_per_month']=$clients_month;
	    }
	    if (isset($num_updates_month)){
	        $stats['clients']['freq_updates_per_month']=$num_updates_month;
	    }
	    if (isset($change_releases)){
	        $stats['clients']['change_releases']=$change_releases;
	    }
	    if (isset($change_flavour)){
	        $stats['clients']['change_flavours']=$change_flavour;
	    }
	    $stats['debug_query_time']=strval(number_format($this->times,5));
	    if (file_exists($this->ka_file)){
		    $stats['debug_keep_alive']=date('Y-m-d H:i',file_get_contents($this->ka_file));
	    }
	    return json_encode($stats);
	}

	function get_historic_data(){
		$this->load_alias();
		$obj=[];
		$this->times=0;
		foreach ($this->info_distro['distros'] as $distro){
			$dname=$distro['name'];
			$dlike=$distro['like'];
			$obj[$dname]=array();
			foreach ($distro['sabor'] as $sabor){
				$sname=$sabor['name'];
				$slike=$sabor['like'];
				$obj[$dname][$sname][]=$this->get_chart($dlike,$slike,'current');
				$obj[$dname][$sname][]=$this->get_chart($dlike,$slike,'old');
				$obj[$dname][$sname][]=$this->get_chart($dlike,$slike,'very_old');
			}
		}
		$obj['debug_query_time']=strval(number_format($this->times,3));
		
		if (file_exists($this->ka_file)){
		    $obj['debug_keep_alive']=date('Y-m-d H:i',file_get_contents($this->ka_file));
		}
		return json_encode($obj);
	}
	function get_chart($version='',$sabor='',$type='current'){
	        if ($version != ''){
	            $version = " and Releases_name = '$version' ";
	        }
	        if ($sabor != ''){
	            $sabor = " and Flavours_name = '$sabor' ";
	        }
	        $order=" order by count desc limit 10 ";
	        $group=" group by app ";
	        
                $where=$this->dates['date_'.$type]." $version $sabor ";
                $where_clients=$this->dates['date_'.$type]." $version $sabor ";

		$sql="SELECT string as app,sum(count) as count from RecvPackages where $where $group $order";
		$sql_clients = "select count(distinct Client_uid) as count from Client_Versions where $where_clients $order";

		return array($this->get_result_from_sql($sql),$this->get_clients_from_sql($sql_clients));
	}
	function get_clients_from_sql($sql){
	        $stime=microtime(true);
		if ($result=$this->dbconn->query($sql)){
		        $etime=microtime(true);
		        $this->times+=($etime-$stime);
			while($row=$result->fetch_array(MYSQLI_ASSOC)){
				if (isset($row['count'])){
					return array('nclients'=>$row['count']);
				}
			}
			return array('nclients'=>'not available');
		}else{
			return array('nclients'=>$this->dbconn->error);
		}
		
	}
	function get_result_from_sql($sql){
	        $stime=microtime(true);
		if ($result=$this->dbconn->query($sql)){
		        $etime=microtime(true);
		        $this->times+=($etime-$stime);
			$obj2=[];
			$nobj=0;
			while($row=$result->fetch_array(MYSQLI_ASSOC)){
				if (array_key_exists($row['app'],$this->alias)){
					if (! empty($this->alias[$row['app']])){
						if ($nobj < 10)
							$obj2[$this->alias[$row['app']]]=$row['count'];
						$nobj++;
					}
				}else{
					if ($nobj < 10)
						$obj2[$row['app']]=$row['count'];
					$nobj++;
				}
			}
			return $obj2;
		}else{
		    return $this->dbconn->error;
		}
	}

} 

?>
