<?php 
function call_bd(){
	return function($request,$response,$service){
		$data=json_decode($request->stats,true);
		
		$db = new DB;
		$db->connect();
		try{
			if (isset($data['vers'])){
			    $version=trim($data['vers']);
			}else{
			    return 'NOK';
			}
			if (isset($data['sab'])){
			    $sabor=trim($data['sab']);
			}else{
			    return 'NOK';
			}
			if (isset($data['uid'])){
			    $uid=trim($data['uid']);
			}else{
			    return 'NOK';
			}
			if ($version == '' or $sabor == '' or $uid == ''){
			    return 'NOK';
			}
			if (isset($data['date'])){
			    $db->send_data($uid,$version,$sabor,json_decode($data['stats'],true),$data['date']);
			}else{
			    $db->send_data($uid,$version,$sabor,json_decode($data['stats'],true));
			}
		}catch (Exception $e){
		        //error_log($e);
			$db->disconnect();
			return 'NOK';
		}
		$db->disconnect();
		return 'OK';
	};
}
function call_get_stats(){
	return function($request,$reponse,$service){

		$db = new DB;
		$db->connect();
		echo $db->get_historic_data();
		$db->disconnect();
	};
}

function call_get_extended_stats(){
	return function($request,$reponse,$service){
	        $app=$request->param('app');
		$db = new DB;
		$db->connect();
		echo $db->get_extended_data($app);
		$db->disconnect();
	};
}

function call_show_stats(){

return function($request,$reponse,$service){

echo '<html>
  <head>
    <!--Load the AJAX API-->
    <!--<script type="text/javascript" src="https://www.google.com/jsapi"></script>-->
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="graph.js"></script>

    <script type="text/javascript">
        google.charts.load("current", {packages: ["corechart"],"language":"es"});
        google.charts.setOnLoadCallback(doChart);
    </script>
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="graph.js"></script>
    <link href="ui/jquery-ui.css" rel="stylesheet">
    <link href="graph.css" rel="stylesheet">
    <script type="text/javascript" src="ui/jquery-ui.js"></script>
  </head>
  <body>
  <div id="header"><span class="title">Lliurex-Analytics <a class="go_to_other" href="ShowExtendedStats">[Extended stats]</a></span><div id="stats_box"></div></div>
  <div id="accordion"></div>
  </body>
</html>
';

};

}

function call_show_extended_stats(){

return function($request,$reponse,$service){

echo '<html>
  <head>
    <!--Load the AJAX API-->
    <!--<script type="text/javascript" src="https://www.google.com/jsapi"></script>-->
    <script type="text/javascript" src="https://www.gstatic.com/charts/loader.js"></script>
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="graph.js"></script>

    <script type="text/javascript">
        google.charts.load("current", {packages: ["corechart"],"language":"es"});
        google.charts.setOnLoadCallback(doExtendedChart);
    </script>
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="graph.js"></script>
    <link href="ui/jquery-ui.css" rel="stylesheet">
    <link href="graph.css" rel="stylesheet">
    <script type="text/javascript" src="ui/jquery-ui.js"></script>
    <script type="text/javascript">$(document).ready(function(){function send_query(){window.location.href=window.location.pathname+"?app="+$("#query_box>input").val()};$("#query_box>input").on("keyup",function(e){if (e.keyCode == 13){send_query()}});$("#query_box>button").click(send_query)});</script>
  </head>
  <body>
  <div id="header"><div id="query_box"><span>Search by app:</span><input type="search" name="app_search"></input><button>Search</button></div><span class="title">Lliurex-Analytics <a class="go_to_other" href="ShowStats">[Simple stats]</a></span><div id="stats_box"></div></div>
  <div id="accordion"></div>
  </body>
</html>
';

};

}


?>